-module(sharedvarserver_tests).
-import(sharedvarserver,[start/1]).
-import(testing,[dotests/2,eqTest/3]).
-export([main/0, run/2, see/1]).
main() -> dotests("sharedvarserver_tests $Revision: 1.2 $", tests()).
tests() -> compile:file(sharedvarserver),
    S1 = start(0), S2 = start([one]),  % make 2 sharedvar servers
    [eqTest(run(S1, fun(X) -> X+1 end),"==",1), 
     eqTest(see(S1),"==",1),
     eqTest(run(S1, fun(X) -> X+4 end),"==",5),
     eqTest(run(S1, fun(X) -> X*X end),"==",25),
     eqTest(run(S1, fun(X) -> X*X end),"==",625),
     eqTest(see(S1),"==",625),
     eqTest(see(S2),"==",[one]),
     eqTest(run(S2, fun(Hist) -> [two|Hist] end),"==",[two,one]),
     eqTest(run(S2, fun(Hist) -> [three|Hist] end),"==",[three,two,one]),
     eqTest(see(S2),"==",[three,two,one]),
     eqTest(run(S2, fun(Hist) -> [4|Hist] end),"==",[4,three,two,one]),
     eqTest(run(S2, fun([N|Hist]) -> [N+1|[N|Hist]] end),"==",[5,4,three,two,one])   ].
% functions to help with testing, NOT for you to implement
-spec run(S::pid(), F::fun((State::any()) -> any())) -> any().
run(S, F) ->
    S ! {self(), {run, F}},
    receive {S, {result, Val}} -> Val after 1000 -> wrong end.
-spec see(S::pid()) -> any().
see(S) ->
    S ! {self(), see},
    receive {S, Value} -> Value after 1000 -> wrong end.
